﻿package classes {
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;

	public class GomuMushi extends Sprite {
		
		private var _container:Sprite;
		private var _GomuMushi:mc_GomuMushi;
		private var _line:Sprite;
		
		private var _spring:Number = 0.1;
		private var _targetX:Number = 0;
		private var _targetY:Number = stage.stageHeight / 2;
		private var _vx:Number = 0;
		private var _vy:Number = 0;
		private var _oldX:Number = 0;
		private var _oldY:Number = 0;
		private var _friction:Number = 0.95;
		
		private var _mushidrag:Boolean = false;
		private var _linedrag:Boolean = false;
		private var _linelength:Number = stage.stageHeight / 2;
		private var _onDragflg:Boolean = false;
		
		public function get vx():Number { return _vx; }
		
		public function GomuMushi() {
			init();
		}
		
		public function init() {
			
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			_container = new Sprite();
			addChild(_container);
			_container.x = stage.stageWidth / 2;
			
			_line = new Sprite();
			_container.addChild(_line);
			_line.buttonMode = true;
			
			_GomuMushi = new mc_GomuMushi();
			_container.addChild(_GomuMushi);
			_GomuMushi.buttonMode = true;
			
			_GomuMushi.addEventListener(Event.ENTER_FRAME , onEnterFrameGomuMushi);
			_GomuMushi.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDownGomuMushi);
			_GomuMushi.addEventListener(MouseEvent.MOUSE_UP, onMouseUpGomuMushi);
			_line.addEventListener(Event.ENTER_FRAME , onEnterFrameLine);
			_line.addEventListener(MouseEvent.ROLL_OVER , onRollOverLine);
			
			stage.addEventListener(Event.RESIZE , onStageResize);
			addEventListener("onDrag" , onDrag);
			addEventListener("onDrop" , onDrop);
		}
		
		private function onEnterFrameGomuMushi(e:Event):void {
			
			if (_linedrag) {
				var xm:Number = _container.mouseX;
				var ym:Number = _container.mouseY;
				var len:Number = Math.sqrt( (xm * xm) + (ym * ym) );
				if ( len > _linelength) {
					_linedrag = false;
					_targetX =  0;
					_targetY =  stage.stageHeight / 2;
				} else {
					_targetX =  xm;
					_targetY =  ym + _linelength - len;
				}
			} else {
				_targetX =  0;
				_targetY =  stage.stageHeight / 2;
			}
			var dx:Number = _targetX - _GomuMushi.x;
			var dy:Number = _targetY - _GomuMushi.y;
			var ax:Number = dx * _spring;
			var ay:Number = dy * _spring;
			_vx += ax;
			_vy += ay;
			_vx *= _friction;
			_vy *= _friction;
			_GomuMushi.x += _vx;
			_GomuMushi.y += _vy;
		} 
		
		private function onEnterFrameLine(e:Event) {
			
			var cY:Number;
			if (_linedrag) {
				if (!_onDragflg) {
					dispatchEvent(new Event("onDrag"));
				}
				var ym:Number = _container.mouseY;
				cY = ym + ( _GomuMushi.y - ym ) / 2;
			} else {
				if ( (_onDragflg) && (!_mushidrag) ) {
					dispatchEvent(new Event("onDrop"));
				}
				cY = _GomuMushi.y / 2;
			}
			
			_line.graphics.clear();
			_line.graphics.lineStyle(2, 0x4BB5C1, 1, true);
			_line.graphics.moveTo(0, 0);
			if (_linedrag) {
				_line.graphics.curveTo(0 , _GomuMushi.y /2 , _container.mouseX , _container.mouseY);
			}
			_line.graphics.curveTo(_targetX , cY , _GomuMushi.x, _GomuMushi.y);
			_line.graphics.endFill();
			
		}
		
		private function onMouseDownGomuMushi(e:MouseEvent) {
			_mushidrag = true;
			dispatchEvent(new Event("onDrag"));
			_GomuMushi.removeEventListener(Event.ENTER_FRAME , onEnterFrameGomuMushi);
			_GomuMushi.startDrag();
			addEventListener(Event.ENTER_FRAME, trackVelocity);
		}
		
		private function onMouseUpGomuMushi(e:MouseEvent) {
			_mushidrag = false;
			dispatchEvent(new Event("onDrop"));
			_GomuMushi.stopDrag();
			removeEventListener(Event.ENTER_FRAME, trackVelocity);
			_GomuMushi.addEventListener(Event.ENTER_FRAME , onEnterFrameGomuMushi);
		}
		
		private function trackVelocity(e:Event) {
			_vx = _GomuMushi.x - _oldX;
			_vy = _GomuMushi.y - _oldY;
			_oldX = _GomuMushi.x;
			_oldY = _GomuMushi.y;
		}
		
		private function onRollOverLine(e:Event) {
			_linedrag = true;
		}
		
		private function onStageResize(e:Event) {
			_container.x = stage.stageWidth / 2;
			_targetY = stage.stageHeight / 2;
			_linelength = stage.stageHeight / 2;
		}
		
		private function onDrag(e:Event) {
			_onDragflg = true;
			_GomuMushi.onDrag();
		}
		
		private function onDrop(e:Event) {
			_onDragflg = false;
			_GomuMushi.onDrop();
		}
	}
	
}